<?php
/*====================================================*/
/* Демонстрационная программа, извлекающая информацию */
/* из  ленты  новостей главной страницы сайта журнала */
/* "Системный администратор" в текстовый файл.        */
/*----------------------------------------------------*/
/* Автор: Игорь Сергеевич Орещенков, январь 2018.     */
/* Среда разработки: AkelPad 4.9.8 + PHP 7.1.9.       */
/*====================================================*/
require_once 'iahtml.php';
$url = 'http://samag.ru/';
$cache = 'samag.htm';
$text = 'samag.txt';
/*-----------------------------------------------------------------------*/
/* 1. Загрузка главной страницы сайта журнала "Системный администратор". */
/*-----------------------------------------------------------------------*/
if (!file_exists ($cache)):
	/* Загрузка главной страницы сайта журнала "Системный администратор"... */
	$html = file_get_contents ($url);
	if ($html !== FALSE):
		/* ... и сохранение её в кеш-файле, чтобы не создавать нагрузки на сайт */
		/* при последующих запусках программы. */
		$f = fopen ($cache, 'w');
		if ($f !== FALSE):
			fputs ($f, $html);
			fclose ($f);
		else:
			echo "ERROR: can't open file \"$cache\" for writing." . PHP_EOL;
		endif;
	endif;
else:
	/* Загрузка главной страницы сайта из кеш-файла. */
	$html = file_get_contents ($cache);
endif;
/*--------------------------------------*/
/* 2. Обработка загруженной информации. */
/*--------------------------------------*/
$info = FALSE;
if ($html !== FALSE):
	$info = ExtractInfo ($html);
else:
	echo 'ERROR: No HTML for parsing.' . PHP_EOF;
endif;
/*--------------------------------------------------*/
/* 3. Запись результата обработки в текстовый файл. */
/*--------------------------------------------------*/
if ($info !== FALSE):
	$f = fopen ($text, 'w');
	if ($f != FALSE):
		fputs ($f, implode (PHP_EOL, $info));
		fclose ($f);
		echo "DONE: news are extracted to the file \"$text\"" . PHP_EOL;
	else:
		echo "ERROR: can't open file \"$text\" for writing." . PHP_EOL;
	endif;
endif;
/*============================================*/
/* Извлечение необходимой информации из HTML. */
/*============================================*/
function ExtractInfo (&$html)
{
	$info = array ();
	$tags = array (
		'span' => array ('SPAN', 'span'),
		'/span' => array ('/SPAN', '/span'),
		'p' => array ('P', 'p'),
		'/p' => array ('/P', '/p')
	);
	$tage = FALSE;
	/* "Прыжок" к содержимому ленты новостей. */
	$p = strpos ($html, '///Main Content///');
	/* Цикл извлечения новостных блоков. */
	$i = 0;
	do {
		/* Поиск заголовка новости. */
		$tagb = iaFindTagOneOf ($p, $html, $tags['span']);
		$tage = iaFindTagOneOf ($tagb, $html, $tags['/span']);
		/* Обработка заголовка новости. */
		if (iaFoundTagAttr ($tagb, 'class') == 'blockTitle'):
			$s = iaFoundElementContent ($html, $tagb, $tage);
			if ($s !== FALSE):
				$s = trim (strip_tags ($s));
				$info[] = "Title $i: [$s]";
			endif;
			/* Поиск текста новости. */
			$tagb = iaFindTagOneOf ($tage, $html, $tags['p']);
			$tage = iaFindTagOneOf ($tage, $html, $tags['/p']);
			/* Обработка текста новости. */
			if ($tage !== FALSE):
				$s = iaFoundElementContent ($html, $tagb, $tage);
				if ($s !== FALSE):
					$s = trim (strip_tags ($s));
					$info[] = "Content $i: [$s]";
				endif;
			endif;
		endif;
		$p = iaFoundTagAfterPos ($tage);
		$i++;
	} while ($p !== FALSE and $i < 10);
	return $info;
}
?>